.386
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib

;**********************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;**********************************************************************************************************

WINWIDTH            equ 160
WINHEIGHT           equ 120

IDTIMER             equ 12345
PERIOD              equ 50              ;update position ever 50ms (0.05s)
WAITMAX             equ (5000/PERIOD)   ;wait 5 seconds before finishing

COLOR_MY_BLUE       equ 0ff8080h

;**********************************************************************************************************

.data
AppName     db "Pup",0
popup_msg   db "Wohoo! I'm a popup!!"
wrect       RECT <0,0,WINWIDTH-2,WINHEIGHT-2>

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
workArea    RECT        <?>
winx        DWORD       ?
winy        DWORD       ?
waiter      DWORD       ?
ps          PAINTSTRUCT <?>
hDC         HDC         ?
hBrush      HBRUSH      ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;** App window stuff **************************************************************************************
WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov wc.cbSize,SIZEOF wc
    mov wc.style,CS_HREDRAW or CS_VREDRAW
    mov wc.lpfnWndProc,OFFSET WndProc
    mov wc.cbClsExtra,NULL
    mov wc.cbWndExtra,NULL
    mov eax,hInstance
    mov wc.hInstance,eax
    mov wc.hbrBackground,COLOR_WINDOW+1
    mov wc.lpszMenuName,NULL
    mov wc.lpszClassName,OFFSET AppName
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov wc.hIcon,eax
    mov wc.hIconSm,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov wc.hCursor,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR AppName,ADDR AppName,WS_POPUP or WS_BORDER or WS_SYSMENU,0,0,WINWIDTH,WINHEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        .WHILE TRUE
            invoke GetMessage, ADDR msg,NULL,0,0
            .BREAK .IF(!eax)
            invoke TranslateMessage, ADDR msg
            invoke DispatchMessage, ADDR msg
        .ENDW
        mov eax,msg.wParam
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_PAINT ----------------------------------------------------------------------------------------
    .IF (eax==WM_PAINT)
        invoke BeginPaint, hwnd,ADDR ps
        mov hDC,eax
        invoke CreateSolidBrush, COLOR_MY_BLUE
        mov hBrush,eax
        invoke FillRect, hDC,ADDR wrect,hBrush
        invoke GetStockObject, DEFAULT_GUI_FONT
        invoke SelectObject, hDC,eax
        invoke SetBkMode, hDC,TRANSPARENT
        invoke TextOut, hDC,28,53,ADDR popup_msg,SIZEOF popup_msg
        invoke DeleteObject, hBrush
        invoke EndPaint, hwnd,ADDR ps
;-- WM_TIMER ----------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_TIMER)
        mov eax,wParam
        .IF (eax==IDTIMER)
            mov edx,winy
            mov eax,[workArea].bottom
            sub edx,4           ;move up 4 pixels
            sub eax,WINHEIGHT
            .IF (edx<eax)       ;must be at top, so wait a bit
                mov eax,waiter
                dec eax
                mov waiter,eax
                .IF (eax==0)
                    invoke PostMessage, hwnd,WM_CLOSE,NULL,NULL
                .ENDIF
            .ELSE
                mov winy,edx
                invoke MoveWindow, hwnd,winx,edx,WINWIDTH,WINHEIGHT,TRUE
            .ENDIF
        .ENDIF
;-- WM_CREATE ---------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke SystemParametersInfo, SPI_GETWORKAREA,NULL,ADDR workArea,NULL
        mov ecx,[workArea].right
        mov edx,[workArea].bottom
        sub ecx,WINWIDTH
        ;sub edx,WINHEIGHT
        mov winx,ecx
        mov winy,edx
        invoke MoveWindow, hwnd,ecx,edx,WINWIDTH,WINHEIGHT,TRUE
        mov eax,WAITMAX
        mov waiter,eax
        invoke SetTimer, hwnd,IDTIMER,PERIOD,NULL
;-- WM_DESTROY --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke KillTimer, hwnd,IDTIMER
        invoke PostQuitMessage, NULL
;-- default -----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

end start
